-- C:\PROJEKTE\VIRTEX_II_XC2V250_BOARD\FPGA\MYPROCESSORIPLIB\PCORES\OPB_USB_FT245_V1_00_B\DEVL\CORE_SIM
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Thu Mar 17 19:05:54 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT user_logic
		GENERIC (
			C_DWIDTH : INTEGER;
			C_NUM_CE : INTEGER
		);
		PORT (
			usb_data_I : In  std_logic_vector (0 TO 7);
			usb_data_O : Out  std_logic_vector (0 TO 7);
			usb_data_T : Out  std_logic;
			usb_RD_n : Out  std_logic;
			usb_WR : Out  std_logic;
			usb_TXE_n : In  std_logic;
			usb_RXF_n : In  std_logic;
			Bus2IP_Clk : In  std_logic;
			Bus2IP_Reset : In  std_logic;
			Bus2IP_Data : In  std_logic_vector (0 TO 7);
			Bus2IP_BE : In  std_logic_vector (0 DOWNTO 0);
			Bus2IP_RdCE : In  std_logic_vector (0 TO 1);
			Bus2IP_WrCE : In  std_logic_vector (0 TO 1);
			IP2Bus_Data : Out  std_logic_vector (0 TO 7);
			IP2Bus_Ack : Out  std_logic;
			IP2Bus_Retry : Out  std_logic;
			IP2Bus_Error : Out  std_logic;
			IP2Bus_ToutSup : Out  std_logic
		);
	END COMPONENT;

	SIGNAL usb_data_I : std_logic_vector (0 TO 7);
	SIGNAL usb_data_O : std_logic_vector (0 TO 7);
	SIGNAL usb_data_T : std_logic;
	SIGNAL usb_RD_n : std_logic;
	SIGNAL usb_WR : std_logic;
	SIGNAL usb_TXE_n : std_logic;
	SIGNAL usb_RXF_n : std_logic;
	SIGNAL Bus2IP_Clk : std_logic;
	SIGNAL Bus2IP_Reset : std_logic;
	SIGNAL Bus2IP_Data : std_logic_vector (0 TO 7);
	SIGNAL Bus2IP_BE : std_logic_vector (0 DOWNTO 0);
	SIGNAL Bus2IP_RdCE : std_logic_vector (0 TO 1);
	SIGNAL Bus2IP_WrCE : std_logic_vector (0 TO 1);
	SIGNAL IP2Bus_Data : std_logic_vector (0 TO 7);
	SIGNAL IP2Bus_Ack : std_logic;
	SIGNAL IP2Bus_Retry : std_logic;
	SIGNAL IP2Bus_Error : std_logic;
	SIGNAL IP2Bus_ToutSup : std_logic;

BEGIN
	UUT : user_logic
	GENERIC MAP (
		C_DWIDTH => 8,
		C_NUM_CE => 2
	)
	PORT MAP (
		usb_data_I => usb_data_I,
		usb_data_O => usb_data_O,
		usb_data_T => usb_data_T,
		usb_RD_n => usb_RD_n,
		usb_WR => usb_WR,
		usb_TXE_n => usb_TXE_n,
		usb_RXF_n => usb_RXF_n,
		Bus2IP_Clk => Bus2IP_Clk,
		Bus2IP_Reset => Bus2IP_Reset,
		Bus2IP_Data => Bus2IP_Data,
		Bus2IP_BE => Bus2IP_BE,
		Bus2IP_RdCE => Bus2IP_RdCE,
		Bus2IP_WrCE => Bus2IP_WrCE,
		IP2Bus_Data => IP2Bus_Data,
		IP2Bus_Ack => IP2Bus_Ack,
		IP2Bus_Retry => IP2Bus_Retry,
		IP2Bus_Error => IP2Bus_Error,
		IP2Bus_ToutSup => IP2Bus_ToutSup
	);

	PROCESS -- clock process for Bus2IP_Clk,
	BEGIN
		CLOCK_LOOP : LOOP
		Bus2IP_Clk <= transport '0';
		WAIT FOR 10 ns;
		Bus2IP_Clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		Bus2IP_Clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for Bus2IP_Clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_usb_data_O(
			next_usb_data_O : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (usb_data_O /= next_usb_data_O) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns usb_data_O="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, usb_data_O);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_usb_data_O);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_usb_data_T(
			next_usb_data_T : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (usb_data_T /= next_usb_data_T) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns usb_data_T="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, usb_data_T);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_usb_data_T);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_usb_RD_n(
			next_usb_RD_n : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (usb_RD_n /= next_usb_RD_n) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns usb_RD_n="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, usb_RD_n);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_usb_RD_n);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_IP2Bus_Data(
			next_IP2Bus_Data : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (IP2Bus_Data /= next_IP2Bus_Data) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns IP2Bus_Data="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, IP2Bus_Data);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_IP2Bus_Data);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_IP2Bus_Ack(
			next_IP2Bus_Ack : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (IP2Bus_Ack /= next_IP2Bus_Ack) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns IP2Bus_Ack="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, IP2Bus_Ack);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_IP2Bus_Ack);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_IP2Bus_Retry(
			next_IP2Bus_Retry : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (IP2Bus_Retry /= next_IP2Bus_Retry) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns IP2Bus_Retry="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, IP2Bus_Retry);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_IP2Bus_Retry);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_IP2Bus_Error(
			next_IP2Bus_Error : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (IP2Bus_Error /= next_IP2Bus_Error) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns IP2Bus_Error="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, IP2Bus_Error);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_IP2Bus_Error);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_IP2Bus_ToutSup(
			next_IP2Bus_ToutSup : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (IP2Bus_ToutSup /= next_IP2Bus_ToutSup) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns IP2Bus_ToutSup="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, IP2Bus_ToutSup);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_IP2Bus_ToutSup);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_usb_WR(
			next_usb_WR : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (usb_WR /= next_usb_WR) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns usb_WR="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, usb_WR);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_usb_WR);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		usb_data_I <= transport std_logic_vector'("ZZZZZZZZ"); --Z
		usb_TXE_n <= transport '0';
		usb_RXF_n <= transport '0';
		Bus2IP_Reset <= transport '1';
		Bus2IP_Data <= transport std_logic_vector'("00000000"); --0
		Bus2IP_BE <= transport std_logic_vector'("0"); --0
		Bus2IP_RdCE <= transport std_logic_vector'("00"); --0
		Bus2IP_WrCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 300 ns; -- Time=300 ns
		Bus2IP_Reset <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=500 ns
		Bus2IP_Data <= transport std_logic_vector'("10101010"); --AA
		Bus2IP_WrCE <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 1000 ns; -- Time=1500 ns
		Bus2IP_Data <= transport std_logic_vector'("00000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=1600 ns
		Bus2IP_WrCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 400 ns; -- Time=2000 ns
		usb_data_I <= transport std_logic_vector'("01011010"); --5A
		Bus2IP_RdCE <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 900 ns; -- Time=2900 ns
		usb_data_I <= transport std_logic_vector'("ZZZZZZZZ"); --Z
		Bus2IP_RdCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 500 ns; -- Time=3400 ns
		usb_TXE_n <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=3500 ns
		Bus2IP_Data <= transport std_logic_vector'("11001101"); --CD
		Bus2IP_WrCE <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 300 ns; -- Time=3800 ns
		usb_TXE_n <= transport '0';
		-- --------------------
		WAIT FOR 1000 ns; -- Time=4800 ns
		Bus2IP_Data <= transport std_logic_vector'("00000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=4900 ns
		usb_RXF_n <= transport '1';
		Bus2IP_WrCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 200 ns; -- Time=5100 ns
		Bus2IP_RdCE <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 200 ns; -- Time=5300 ns
		usb_data_I <= transport std_logic_vector'("01110011"); --73
		usb_RXF_n <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=5400 ns
		Bus2IP_Reset <= transport '0';
		-- --------------------
		WAIT FOR 800 ns; -- Time=6200 ns
		usb_data_I <= transport std_logic_vector'("ZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 100 ns; -- Time=6300 ns
		Bus2IP_RdCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 300 ns; -- Time=6600 ns
		Bus2IP_RdCE <= transport std_logic_vector'("10"); --2
		-- --------------------
		WAIT FOR 100 ns; -- Time=6700 ns
		Bus2IP_RdCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=6800 ns
		usb_TXE_n <= transport '1';
		usb_RXF_n <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=6900 ns
		Bus2IP_RdCE <= transport std_logic_vector'("10"); --2
		-- --------------------
		WAIT FOR 100 ns; -- Time=7000 ns
		Bus2IP_RdCE <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 210 ns; -- Time=7210 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION user_logic_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END user_logic_cfg;
